#include "duemila48game.h"

void Duemila48Game::esegui(int n)
{
   int i;
   n = n - 1 ;
   for (i = 0; i < n; i++)
       ruota();

   caduta();
   merge();
   caduta();

   for (i = 0; i < 4 - n; i++)
       ruota();
}

int Duemila48Game::aggiungi_tessera()
{
   int i,j, cont = 0;
   for(i = 0; i < 4; i++)
       for(j = 0; j < 4; j++)
           if (m[i][j] != 0)
               cont++;
   if (cont == 16)
       return 0;
   i = rand()%4;
   j = rand()%4;
   while (m[i][j] != 0)
   {
       i = rand()%4;
       j = rand()%4;
   }
   if (rand()%10 == 9)
       m[i][j] = 4;
   else
       m[i][j] = 2;
   return 1;
}

void Duemila48Game::caduta()
{
   int i,j;
   for(i = 0; i < 4; i++)
       for(j = 1; j < 4; j++)
       {
           int k = j-1;
           while(m[i][k]==0 && k >=0)
               k--;
           m[i][k+1] = m[i][j];
           if (k != j-1 )m[i][j] = 0;
       }
}

void Duemila48Game::merge()
{
   int i,j;
   for(i = 0; i < 4; i++)
       for(j = 0; j < 3; j++)
       {
           if (m[i][j] == m[i][j+1])
           {
               m[i][j]*=2;
               m[i][j+1] = 0;
           }
       }

}

void Duemila48Game::ruota()
{
    int i,j,m2[4][4];
   for(i = 0; i < 4; i++)
       for(j = 0; j < 4; j++)
       {
          m2[i][j]=m[4-1-j][i];

       }

   for(i = 0; i < 4; i++)
       for(j = 0; j < 4; j++)
       {
          m[i][j]=m2[i][j];

       }
}

bool Duemila48Game::vittoria()
{
    for(int i = 0; i < 4; i++)
       for(int j = 0; j < 4; j++)
        if (m[i][j] == 2048)
            return true;
    return false;
}
