/*
  Copyright (C) 2011 Alessandro Bugatti (alessandro.bugatti@istruzione.it)

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

/*! \file
 *  \brief Classe che gestisce la logica del gioco 2048
 *  \author Alessandro Bugatti
 *  \version 0.1
 *  \date  Creazione 05/04/2014
 *  \date  Ultima modifica 05/04/2014
 */

#ifndef DUEMILA48GAME_H
#define DUEMILA48GAME_H

#include <cstdlib>

using namespace std;


class Duemila48Game
{
        int m[4][4];
    public:
        Duemila48Game()
        {
            for(int i = 0; i < 4; i++)
               for(int j = 0; j < 4; j++)
                    m[i][j] = 0;
        }
        int get(int i, int j) const
        {
            return m[i][j];
        }

        void esegui(int n);

        int aggiungi_tessera();

        bool vittoria();

    private:
        void caduta();

        void merge();

        void ruota();

};

#endif // DUEMILA48GAME_H



