/*
  Copyright (C) 2011 Alessandro Bugatti (alessandro.bugatti@istruzione.it)

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

/*! \file
 *  \brief Gioco 2048, versione portable di http://gabrielecirulli.github.io/2048/
 *  \author Alessandro Bugatti
 *  \version 0.1
 *  \date  Creazione 05/04/2014
 *  \date  Ultima modifica 05/04/2014
 */
#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Box.H>
#include <cstdlib>
#include <ctime>
#include "duemila48box.h"

using namespace std;

int main (int argc, char ** argv)
{
  Fl_Window *window;
  Duemila48box *box;

  window = new Fl_Window (400, 400, "2048 portable");
  box = new Duemila48box (0, 0, 400, 400);

  window->end ();
  window->show (argc, argv);
  srand(time(NULL));
  return(Fl::run());
}
